"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var express_1 = __importDefault(require("express"));
var http_1 = __importDefault(require("http"));
var __1 = __importDefault(require("../.."));
var mongodb_if_1 = require("mongodb-if");
/*
 *   RATE LIMITER TEST
 * ---------------------------------
 * Integration test uses call to database therefore cannot be ran as standard unit test
 *
 * Attempts to initialise rate limiter on endpoint
 * Sets endpoint to a small amount of allowed requests every minute
 *
 * USER STEPS:
 *   Once initialised, user must access endpoint on localhost and confirm rate limit occurs after
 *      multiple attempts
 *
 */
var databaseName = 'expressWrapperLimiter';
var testPort = 8080;
var handlerOptions = {
    connectionDomain: 'mongodb://127.0.0.1:27017',
    connectionOptions: {
        useNewUrlParser: true,
        useUnifiedTopology: true,
    },
    dbNameList: [databaseName],
};
var dbHandler = new mongodb_if_1.MongoDBHandler(handlerOptions);
var runTest = function () { return __awaiter(void 0, void 0, void 0, function () {
    var endpoint, limiter, endpoints, app, expressWrapper, httpServer;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: 
            /* Await connection to database */
            return [4 /*yield*/, dbHandler.connect()];
            case 1:
                /* Await connection to database */
                _a.sent();
                endpoint = {
                    name: 'TestEndpoint',
                    path: 'testendpoint',
                    defaultPath: 'path',
                    type: 'GET',
                    limiter: {
                        points: 2,
                        duration: 20,
                        keyPrefix: 'testendpointrx',
                    },
                    execute: function (req, res, headers) {
                        res.status(200).send({ text: 'You have not yet been rate limited!' });
                    },
                };
                limiter = {
                    mongoClient: dbHandler.getDatabaseObject(databaseName),
                };
                endpoints = [endpoint];
                app = express_1.default();
                expressWrapper = new __1.default({
                    endpoints: endpoints,
                    expressApp: app,
                    limiter: limiter,
                });
                /* Await app listeners */
                return [4 /*yield*/, expressWrapper.initialise()];
            case 2:
                /* Await app listeners */
                _a.sent();
                httpServer = http_1.default.createServer(app);
                httpServer.listen(testPort);
                httpServer.once('error', function (e) {
                    throw Error(e.toString());
                });
                httpServer.once('listening', function () {
                    /* Inform the console that the server is up and running */
                    console.log("[HTTP] Server running, listening on " + testPort + "...");
                    console.log("To test the rate limiter, head to 'http://localhost:" + testPort + "/path/testendpoint' in your browser and refresh until the limit is reached");
                });
                return [2 /*return*/];
        }
    });
}); };
runTest();
